Attribute VB_Name = "modMain"
Public Const MaxArgs As Integer = 10
Public Const WordsBack As Integer = 5
Public Const TopicsBack = 5
Public Const MaxSentence = 50

Option Explicit

Public Type ParseSlashType
  cmd As String
  arg(MaxArgs) As String
End Type

Public Type ParseType
  server As Boolean
  nick As String
  user As String
  host As String
  code As Integer
  cmd As String
  arg(MaxArgs) As String
  argcount As Integer
End Type

Public Type LastWordType
  words() As String
  num_words As Integer
End Type

Public Type ChainWord
  text As String
  rep() As Long
  NumReps As Long
End Type

Public Type ChainType
  name As String
  word() As ChainWord
  NumWords As Long
End Type

Public Type TopicType
  word As String
  count As Integer
End Type

Public Type ChanInfoType
  name As String
  topic As String
  users() As String
  numusers As Integer
  buffer As String
  last_words(WordsBack) As LastWordType
  Listen As Integer
  Participate As Integer
  Use_AI As Integer
  Chain As ChainType
  topics() As TopicType
  num_topics As Integer
  percent As Integer
End Type

Public server As String, port As Integer
Public nick As String, realname As String
Public user As String, host As String
Public NL As String, connected As Boolean
Public buffer As String, CurChan As Integer
Public ChanInfo() As ChanInfoType
Public NumChans As Integer, Path As String
Public Bye As Boolean


'Server reply code constants

Public Const Err_NoSuchNick As Integer = 401
Public Const Err_NoSuchServer As Integer = 402
Public Const Err_NoSuchChannel As Integer = 403
Public Const Err_CannotSendToChan As Integer = 404
Public Const Err_TooManyChannels As Integer = 405
Public Const Err_WasNoSuchNick As Integer = 406
Public Const Err_TooManyTargets As Integer = 407
Public Const Err_NoOrigin As Integer = 409
Public Const Err_NoRecipient As Integer = 411
Public Const Err_NoTextToSend As Integer = 412
Public Const Err_NoTopLevel As Integer = 413
Public Const Err_WildTopLevel As Integer = 414
Public Const Err_UnknownCommand As Integer = 421
Public Const Err_NoMOTD As Integer = 422
Public Const Err_NoAdminInfo As Integer = 423
Public Const Err_FileError As Integer = 424
Public Const Err_NoNickNameGiven As Integer = 431
Public Const Err_ErroneousNickname As Integer = 432
Public Const Err_NicknameInUse As Integer = 433
Public Const Err_NickCollision As Integer = 436
Public Const Err_UserNotInChannel As Integer = 441
Public Const Err_NotOnChannel As Integer = 442
Public Const Err_UserOnChannel As Integer = 443
Public Const Err_NoLogin As Integer = 444
Public Const Err_SummonDisabled As Integer = 445
Public Const Err_UserDisabled As Integer = 446
Public Const Err_NotRegistered As Integer = 451
Public Const Err_NeedMoreParams As Integer = 461
Public Const Err_AlreadyRegistered As Integer = 462
Public Const Err_NopermForHost As Integer = 463
Public Const Err_PasswdMismatch As Integer = 464
Public Const Err_YoureBannedCreep As Integer = 465
Public Const Err_KeySet As Integer = 467
Public Const Err_ChannelIsFull As Integer = 471
Public Const Err_UnknownMode As Integer = 472
Public Const Err_InviteOnlyChan As Integer = 473
Public Const Err_BannedFromChan As Integer = 474
Public Const Err_BadChannelKey As Integer = 475
Public Const Err_NoPrivileges As Integer = 481
Public Const Err_ChanOPrivsNeeded As Integer = 482
Public Const Err_CantKillServer As Integer = 483
Public Const Err_NoOperHost As Integer = 491
Public Const Err_UmodeUnknownFlag As Integer = 501
Public Const Err_UsersDontMatch As Integer = 502

Public Const Rpl_None As Integer = 300
Public Const Rpl_UserHost As Integer = 302
Public Const Rpl_IsOn As Integer = 303
Public Const Rpl_Away As Integer = 301
Public Const Rpl_UnAway As Integer = 305
Public Const Rpl_NowAway As Integer = 306
Public Const Rpl_WhoIsUser As Integer = 311
Public Const Rpl_WhoIsServer As Integer = 312
Public Const Rpl_WhoIsOperator As Integer = 313
Public Const Rpl_WhoIsIdle As Integer = 317
Public Const Rpl_EndOfWhois As Integer = 318
Public Const Rpl_WhoIsChannels As Integer = 319
Public Const Rpl_WhoWasUser As Integer = 314
Public Const Rpl_EndOfWhoWas As Integer = 369
Public Const Rpl_ListStart As Integer = 321
Public Const Rpl_List As Integer = 322
Public Const Rpl_ListEnd As Integer = 323
Public Const Rpl_ChannelModeIs As Integer = 324
Public Const Rpl_NoTopic As Integer = 331
Public Const Rpl_Topic As Integer = 332
Public Const Rpl_Inviting As Integer = 341
Public Const Rpl_Summoning As Integer = 342
Public Const Rpl_Version As Integer = 351
Public Const Rpl_WhoReply As Integer = 352
Public Const Rpl_EndOfWho As Integer = 315
Public Const Rpl_NamReply As Integer = 353
Public Const Rpl_EndOfNames As Integer = 366
Public Const Rpl_Links As Integer = 364
Public Const Rpl_EndOfLinks As Integer = 365
Public Const Rpl_BanList As Integer = 367
Public Const Rpl_EndOfBanList As Integer = 368
Public Const Rpl_Info As Integer = 371
Public Const Rpl_EndOfInfo As Integer = 374
Public Const Rpl_MOTDStart As Integer = 375
Public Const Rpl_MOTD As Integer = 372
Public Const Rpl_EndOfMOTD As Integer = 376
Public Const Rpl_YoureOper As Integer = 381
Public Const Rpl_Rehashing As Integer = 382
Public Const Rpl_Time As Integer = 391
Public Const Rpl_UsersStart As Integer = 392
Public Const Rpl_Users As Integer = 393
Public Const Rpl_EndOfUsers As Integer = 394
Public Const Rpl_NoUsers As Integer = 395
Public Const Rpl_TraceLink As Integer = 200
Public Const Rpl_TraceConnecting As Integer = 201
Public Const Rpl_TraceHandShake As Integer = 202
Public Const Rpl_TraceUnknown As Integer = 203
Public Const Rpl_TraceOperator As Integer = 204
Public Const Rpl_TraceUser As Integer = 205
Public Const Rpl_TraceServer As Integer = 206
Public Const Rpl_TraceNewType As Integer = 208
Public Const Rpl_TraceLog As Integer = 261
Public Const Rpl_StatsLinkInfo As Integer = 211
Public Const Rpl_StatsCommands As Integer = 212
Public Const Rpl_StatsCLine As Integer = 213
Public Const Rpl_StatsNLine As Integer = 214
Public Const Rpl_StatsILine As Integer = 215
Public Const Rpl_StatsKLine As Integer = 216
Public Const Rpl_StatsYLine As Integer = 218
Public Const Rpl_EndOfStats As Integer = 219
Public Const Rpl_StatsLLine As Integer = 241
Public Const Rpl_StatsUpTime As Integer = 242
Public Const Rpl_StatsOLine As Integer = 243
Public Const Rpl_StatsHLine As Integer = 244
Public Const Rpl_StatsUModeIs As Integer = 221
Public Const Rpl_LUserClient As Integer = 251
Public Const Rpl_LUserOp As Integer = 252
Public Const Rpl_LUserUnknown As Integer = 253
Public Const Rpl_LUserChannels As Integer = 254
Public Const Rpl_LUserMe As Integer = 255
Public Const Rpl_AdminMe As Integer = 256
Public Const Rpl_AdminLoc1 As Integer = 257
Public Const Rpl_AdminLoc2 As Integer = 258
Public Const Rpl_AdminEmail As Integer = 259

Public Sub SaveAI(chan As Integer, fn As String)

Dim fl As Long, temp As String, j As Long
Dim k As Long

temp = ChanInfo(chan).name + Chr(10)

For j = 1 To ChanInfo(chan).Chain.NumWords
  temp = temp + ChanInfo(chan).Chain.word(j).text + ","
  For k = 1 To ChanInfo(chan).Chain.word(j).NumReps
    temp = temp + Skim(ChanInfo(chan).Chain.word(j).rep(k)) + ","
  Next k
  temp = temp + Chr(10)
Next j
  
fl = FreeFile
Open fn For Output As #fl
Close #fl
fl = FreeFile
Open fn For Binary Access Write As #fl
Put #fl, 1, temp
Close #fl

End Sub


Public Sub LoadAI(fn As String)

Dim fl As Long, temp As String, m As String
Dim j As Long, t As String, stat As Integer
Dim k As Long, c As String, st As Integer
Dim m2 As String

fl = FreeFile
Open fn For Binary Access Read As #fl
temp = Input(LOF(fl), #fl)
Close #fl

NumChans = NumChans + 1
ReDim Preserve ChanInfo(NumChans)
ChanInfo(NumChans).Use_AI = NumChans
frmMain.UpdateChan

For j = 1 To Len(temp)
  m = Mid(temp, j, 1)
  If m = Chr(10) Then
    Select Case stat
    Case 0
      ChanInfo(NumChans).name = t
      stat = 1
    Case 1
      ChanInfo(NumChans).Chain.NumWords = ChanInfo(NumChans).Chain.NumWords + 1
      ReDim Preserve ChanInfo(NumChans).Chain.word(ChanInfo(NumChans).Chain.NumWords)
      ReDim Preserve ChanInfo(NumChans).Chain.word(ChanInfo(NumChans).Chain.NumWords).rep(0)
      c = ""
      st = -1
      For k = 1 To Len(t)
        m2 = Mid(t, k, 1)
        If m2 = "," Then
          st = st + 1
          If st = 0 Then
            ChanInfo(NumChans).Chain.word(ChanInfo(NumChans).Chain.NumWords).text = c
          Else
            ChanInfo(NumChans).Chain.word(ChanInfo(NumChans).Chain.NumWords).NumReps = st
            ReDim Preserve ChanInfo(NumChans).Chain.word(ChanInfo(NumChans).Chain.NumWords).rep(st)
            ChanInfo(NumChans).Chain.word(ChanInfo(NumChans).Chain.NumWords).rep(st) = c
          End If
          c = ""
        Else
          c = c + m2
        End If
      Next k
    End Select
    t = ""
  Else
    t = t + m
  End If
Next j

frmMain.lstChannels.AddItem ChanInfo(NumChans).name + " (file)"
frmMain.cmbAI.AddItem ChanInfo(NumChans).name + " (file)"

End Sub


Public Sub ChainSentence(Chn As ChainType, word As String, nick2 As String, chan As Integer)

Dim temp As String, msg As String, c As Integer

temp = RepName(GetRep(Chn, word), nick2)
If temp = "" Then
  WriteInfo "Sorry, word not in AI datbase."
  Exit Sub
End If
msg = RepName(UCase(Left(word, 1)) + Right(word, Len(word) - 1), nick2)
While temp <> "." And temp <> "" And temp <> " " And c < MaxSentence
  c = c + 1
  msg = msg + " " + RepName(temp, nick2)
  temp = GetRep(Chn, temp)
Wend
msg = msg + "."
WriteChannel CurChan, "<" + nick + "> " + msg
frmMain.TCP.SendData "PRIVMSG " + ChanInfo(chan).name + " :" + msg + NL

End Sub

Public Sub ProcessMessage(nick2 As String, target As String, msg As String)

Randomize

Dim i As Integer, k As Long, n As Integer
Dim m As String, temp As String, j As Long
Dim f As Boolean, d As Integer, j2 As Long
Dim j3 As Long, snai As Integer
Dim fn As Integer, FoundMatch() As Integer
Dim FoundNum() As Integer, h As Integer
Dim dm As Integer, DefNum() As Integer, t As String
Dim r As Long, g As Long, s As Long
Dim ui As Long, esc As Boolean, nmsg As String
Dim a As Long, words() As String, num_words As Integer
Dim found() As Boolean
Dim pop_topic(TopicsBack) As String, pop_count(TopicsBack) As Integer
Dim last As String, best As String, bcount As Integer

msg = LCase(msg + " ")
i = FindChanIndex(target)
If i = 0 Then
  Exit Sub
End If
ui = ChanInfo(i).Use_AI

For j = 1 To Len(msg)
  m = Mid(msg, j, 1)
  a = Asc(m)
  If (a < 48 And m <> "-") Or (a > 57 And a < 65 And m <> "`") Or (a > 90 And a < 97 And m <> "_" And m <> "^") Or (a > 122 And a < 128 And m <> "|") Or a > 165 Then
    For k = 1 To ChanInfo(i).numusers
      If LCase(temp) = LCase(ChanInfo(i).users(k)) Or "@" + LCase(temp) = LCase(ChanInfo(i).users(k)) Or "+" + LCase(temp) = LCase(ChanInfo(i).users(k)) Then
        temp = "$n"
        Exit For
      End If
    Next k
    nmsg = nmsg + temp + m
    temp = ""
  ElseIf m = "$" Then
    temp = temp + "$$"
  Else
    temp = temp + m
  End If
Next j
msg = nmsg

Debug.Print msg
  
If ChanInfo(i).Listen = 1 Then
  last = ""
  temp = ""
  For j = 1 To Len(msg)
    m = Mid(msg, j, 1)
    If m = " " Or m = Chr(10) Or j = Len(msg) Then
      If j = Len(msg) And m <> " " Then
        temp = temp + m
      End If
      If t = Chr(1) Or t = ":" Then
        temp = Left(temp, Len(temp) - 1)
      End If
      If temp <> "" Then
        If last = "" Then
          AddChain ChanInfo(i).Chain, ".", temp
        Else
          AddChain ChanInfo(i).Chain, last, temp
        End If
        If Right(temp, 1) = "." Or Right(temp, 1) = "?" Or Right(temp, 1) = "!" Then
          AddChain ChanInfo(i).Chain, temp, "."
          last = "."
        Else
          last = temp
        End If
      End If
      temp = ""
    ElseIf m <> Chr(13) And m <> "." And m <> "," And m <> "?" And m <> "!" And m <> """" And m <> Chr(1) Then
      temp = temp + m
    End If
  Next j
End If

For j = 1 To ChanInfo(i).num_topics
  ChanInfo(i).topics(j).count = ChanInfo(i).topics(j).count - 1
Next j
temp = ""
For j = 1 To Len(msg)
  m = Mid(msg, j, 1)
  If m = " " Or m = Chr(10) Or j = Len(msg) Then
    If j = Len(msg) And m <> " " Then
      temp = temp + m
    End If
    If t = Chr(1) Or t = ":" Then
      temp = Left(temp, Len(temp) - 1)
    End If
    If temp <> "" Then
      f = False
      For k = 1 To ChanInfo(i).num_topics
        If ChanInfo(i).topics(k).word = temp Then
          f = True
          ChanInfo(i).topics(k).count = ChanInfo(i).topics(k).count + 5
          Exit For
        End If
      Next k
      If Not f Then
        ChanInfo(i).num_topics = ChanInfo(i).num_topics + 1
        ReDim Preserve ChanInfo(i).topics(ChanInfo(i).num_topics)
        ChanInfo(i).topics(ChanInfo(i).num_topics).word = temp
        ChanInfo(i).topics(ChanInfo(i).num_topics).count = 5
      End If
    End If
    temp = ""
  ElseIf m <> Chr(13) And m <> "." And m <> "," And m <> "?" And m <> "!" And m <> """" Then
    temp = temp + m
  End If
Next j

For j = 1 To ChanInfo(i).num_topics
  If ChanInfo(i).topics(j).count < 1 Then
    If j < ChanInfo(i).num_topics Then
      For k = j To ChanInfo(i).num_topics - 1
        ChanInfo(i).topics(k).word = ChanInfo(i).topics(k + 1).word
        ChanInfo(i).topics(k).count = ChanInfo(i).topics(k + 1).count
      Next k
    End If
    ChanInfo(i).num_topics = ChanInfo(i).num_topics - 1
    ReDim Preserve ChanInfo(i).topics(ChanInfo(i).num_topics)
  ElseIf ChanInfo(i).topics(j).count > bcount Then
    bcount = ChanInfo(i).topics(j).count
    best = ChanInfo(i).topics(j).word
  End If
  If j >= ChanInfo(i).num_topics Then Exit For
Next j

If ChanInfo(i).Participate = 1 And Int(Rnd(1) * 100) + 1 <= ChanInfo(i).percent Then
  ChainSentence ChanInfo(ui).Chain, ChanInfo(ui).Chain.word(Int(Rnd(1) * ChanInfo(ui).Chain.NumWords) + 1).text, nick2, i
End If

End Sub

Public Function RepName(text As String, rep As String) As String

Dim j As Integer, esc As Boolean, m As String

For j = 1 To Len(text)
  m = Mid(text, j, 1)
  If esc Then
    If m = "n" Then
      RepName = RepName + rep
    ElseIf m = "$" Then
      RepName = RepName + "$"
    Else
      RepName = RepName + "$" + m
    End If
    esc = False
  Else
    If m = "$" Then
      esc = True
    Else
      RepName = RepName + m
    End If
  End If
Next j

End Function

Public Sub WriteChannel(num As Integer, msg As String)

ChanInfo(num).buffer = ChanInfo(num).buffer + msg + NL
If CurChan = num Then frmMain.txtLog = frmMain.txtLog + msg + NL

End Sub


Public Function FindNickIndex(chan As Integer, nick As String) As Integer

Dim j As Integer
j = -1

For j = 0 To ChanInfo(chan).numusers
  If LCase(ChanInfo(chan).users(j)) = LCase(nick) Or LCase(ChanInfo(chan).users(j)) = "@" & LCase(nick) Or LCase(ChanInfo(chan).users(j)) = "+" & LCase(nick) Then
    FindNickIndex = j
    Exit For
  End If
Next j

End Function



Public Sub DoCommand(chan As String, msg As String)

Dim i As Integer, j As Integer, p As ParseSlashType
Dim cmd As String, args As String, ui As Integer
Dim start As String, temp As String
i = FindChanIndex(chan)
If frmMain.TCP.State <> sckConnected Then Exit Sub

Randomize

If InStr(msg, " ") > 0 Then
  cmd = Mid(msg, 2, InStr(msg, " ") - 2)
  args = Right(msg, Len(msg) - InStr(msg, " "))
Else
  cmd = Right(msg, Len(msg) - 1)
End If
cmd = LCase(cmd)
Select Case cmd
Case "quote"
  frmMain.TCP.SendData args + NL
Case "msg"
  p = ParseSlash(msg, 2)
  frmMain.TCP.SendData "PRIVMSG " + p.arg(1) + " :" + p.arg(2) + NL
  WriteInfo "[To " + p.arg(1) + "] " + p.arg(2) + NL
Case "join"
  p = ParseSlash(msg, 2)
  frmMain.TCP.SendData "JOIN " + p.arg(1)
  If p.arg(2) <> "" Then
    frmMain.TCP.SendData " " + p.arg(2)
  End If
  frmMain.TCP.SendData NL
Case "part"
  If InStr(args, " ") > 0 Then
    WriteInfo "The channel list you entered was invalid." + NL
  Else
    frmMain.TCP.SendData "PART " + args + NL
  End If
Case "me"
  frmMain.TCP.SendData "PRIVMSG " + chan + " :" + Chr(1) + "ACTION " + args + Chr(1) + NL
  WriteChannel i, ":" + nick + " " + args
Case "nick"
  If InStr(args, " ") > 0 Then
    'WriteInfo server, "Invalid nickname." + NL
  Else
    frmMain.TCP.SendData "NICK " + args + NL
  End If
Case "quit"
  If args = "" Then
    frmMain.TCP.SendData "QUIT" + NL
  Else
    frmMain.TCP.SendData "QUIT :" + args + NL
  End If
Case "away"
  If args = "" Then
    frmMain.TCP.SendData "AWAY" + NL
  Else
    frmMain.TCP.SendData "AWAY :" + args + NL
  End If
Case "topic"
  If Left(args, 1) = "#" Or Left(args, 1) = "&" Then
    p = ParseSlash(msg, 2)
    frmMain.TCP.SendData "TOPIC " + p.arg(1) + " :" + p.arg(2) + NL
  Else
    frmMain.TCP.SendData "TOPIC " + chan + " :" + args + NL
  End If
Case "invite"
  p = ParseSlash(msg, 2)
  If p.arg(2) = "" Then
    frmMain.TCP.SendData "INVITE " + p.arg(1) + " " + chan + NL
  Else
    frmMain.TCP.SendData "INVITE " + p.arg(1) + " " + p.arg(2) + NL
  End If
Case "mode"
  If Left(args, 1) <> "+" And Left(args, 1) <> "-" Then
    frmMain.TCP.SendData "MODE " + args + NL
  Else
    frmMain.TCP.SendData "MODE " + chan + " " + args + NL
  End If
Case "kick"
  If Left(args, 1) = "#" Or Left(args, 1) = "&" Then
    p = ParseSlash(msg, 3)
    If p.arg(3) = "" Then
      frmMain.TCP.SendData "KICK " + p.arg(1) + " " + p.arg(2) + NL
    Else
      frmMain.TCP.SendData "KICK " + p.arg(1) + " " + p.arg(2) + " :" + p.arg(3) + NL
    End If
  Else
    p = ParseSlash(msg, 2)
    If p.arg(2) = "" Then
      frmMain.TCP.SendData "KICK " + chan + " " + p.arg(1) + NL
    Else
      frmMain.TCP.SendData "KICK " + chan + " " + p.arg(1) + " :" + p.arg(2) + NL
    End If
  End If
Case "say"
  ui = ChanInfo(CurChan).Use_AI
  p = ParseSlash(msg, 1)
  If p.arg(1) = "" Then
    start = ChanInfo(ui).Chain.word(Int(Rnd(1) * ChanInfo(ui).Chain.word(1).rep(ChanInfo(ui).Chain.word(1).NumReps))).text
  Else
    start = p.arg(1)
  End If
  temp = RepName(GetRep(ChanInfo(ui).Chain, start), "xekul")
  If temp = "" Then
    WriteInfo "Sorry, word not in AI datbase."
    Exit Sub
  End If
  msg = UCase(Left(start, 1)) + Right(start, Len(start) - 1)
  While temp <> "." And temp <> "" And temp <> " "
    msg = msg + " " + RepName(temp, "xekul")
    temp = GetRep(ChanInfo(ui).Chain, temp)
  Wend
  msg = msg + "."
  frmMain.TCP.SendData "PRIVMSG " + ChanInfo(CurChan).name + " :" + msg + NL
Case Else
  WriteInfo "Unknown /command"
End Select

End Sub
Public Sub WriteInfo(txt As String)

frmMain.txtServer.SelStart = Len(frmMain.txtServer)
frmMain.txtServer.SelLength = 0
frmMain.txtServer.SelText = txt + NL

End Sub


Public Function FindChanIndex(chan As String) As Integer

Dim j As Integer

For j = 1 To NumChans
  If LCase(ChanInfo(j).name) = LCase(chan) Then
    FindChanIndex = j
    Exit For
  End If
Next j

End Function

Public Function Parse(ByRef msg As String) As ParseType

Dim i As Integer, count As Integer, j As Integer
Dim temp As String, m As String
Dim Colon As Boolean, f As Integer

'Debug.Print "Parse: /" + msg + "/"

If Left(msg, 1) = ":" Then
  For j = 1 To Len(msg)
    m = Mid(msg, j, 1)
    If m = " " Then
      Parse.server = True
      Exit For
    ElseIf m = "!" Then
      Parse.server = False
      Exit For
    End If
  Next j
Else
  Parse.server = False
End If

If Parse.server Then
  i = InStr(msg, " ")
  count = 0
  For j = i + 1 To Len(msg)
    m = Mid(msg, j, 1)
    If j = Len(msg) Then temp = temp + m
    If (m = " " And Not Colon) Or j = Len(msg) Then
      If count = 0 Then
        Parse.code = Val(temp)
      ElseIf count > 1 Then
        Parse.argcount = Parse.argcount + 1
        Parse.arg(Parse.argcount) = temp
      End If
      count = count + 1
      temp = ""
    ElseIf m = ":" And Not Colon Then
      Colon = True
    Else
      temp = temp + m
    End If
  Next j
Else
  count = 0
  Colon = False
  For j = 1 To Len(msg)
    If Mid(msg, j, 1) <> ":" Then
      f = j
      Exit For
    End If
  Next j
  If InStr(msg, "!") = 0 Or (InStr(msg, ":") > 1 And InStr(msg, "!") > InStr(msg, ":")) Then
    count = 3
  End If
  For j = f To Len(msg)
    m = Mid(msg, j, 1)
    If j = Len(msg) Then temp = temp + m
    If count = 0 And m = "!" Then
      Parse.nick = temp
      temp = ""
      count = count + 1
    ElseIf count = 1 And m = "@" Then
      Parse.user = temp
      temp = ""
      count = count + 1
    ElseIf (m = " " And count > 1 And Not Colon) Or j = Len(msg) Then
      'MsgBox "Count =" + Str(Count) + NL + Skim(j) + "/" + Skim(Len(msg))
      If count = 2 Then
        Parse.host = temp
      ElseIf count = 3 Then
        Parse.cmd = temp
      Else
        Parse.argcount = Parse.argcount + 1
        Parse.arg(Parse.argcount) = temp
      End If
      temp = ""
      count = count + 1
    'ElseIf m = " " Then
      'MsgBox "Colon=" + Str(Colon)
    ElseIf m = ":" And Not Colon Then
      Colon = True
    Else
      temp = temp + m
    End If
  Next j
End If

End Function

Public Function ParseSlash(msg As String, num As Integer) As ParseSlashType

Dim count As Integer, temp As String, m As String
Dim n As Integer, j As Integer

If Left(msg, 1) = "/" Then msg = Right(msg, Len(msg) - 1)

For j = 1 To Len(msg)
  m = Mid(msg, j, 1)
  If j = Len(msg) Then temp = temp + m
  If m = " " Or j = Len(msg) Then
    If count = 0 Then
      ParseSlash.cmd = temp
      n = 1
    Else
      ParseSlash.arg(n) = temp
      n = n + 1
    End If
    If n >= num Then
      ParseSlash.arg(n) = Right(msg, Len(msg) - j)
      Exit Function
    End If
    count = count + 1
    temp = ""
  Else
    temp = temp + m
  End If
Next j

End Function


Public Sub Connect(ByVal tserver As String, ByVal tport As Integer, ByVal tnick As String, ByVal trealname As String, ByVal tuser As String, ByVal thost As String)

server = tserver
port = tport
nick = tnick
realname = trealname
user = tuser
host = thost
With frmMain.TCP
  .RemoteHost = server
  .RemotePort = port
  .Connect
End With
frmMain.Timer.Enabled = True

End Sub
Public Function CleanUp(msg As String) As String

Dim j As Integer, m As String

For j = 1 To Len(msg)
  m = Mid(msg, j, 1)
  If m <> Chr(13) And m <> Chr(10) Then
    CleanUp = CleanUp + m
  End If
Next j

End Function


Public Function Skim(arg) As String

Skim = Str(arg)
If Left(Skim, 1) <> "-" Then Skim = Right(Skim, Len(Skim) - 1)

End Function


Public Sub AddChain(Chn As ChainType, word As String, rep As String)

Dim j As Long, f As Long, r As Long

word = LCase(word)
rep = LCase(rep)

For j = 1 To Chn.NumWords
  If Chn.word(j).text = word Then
    f = j
    Exit For
  End If
Next j
For j = 1 To Chn.NumWords
  If Chn.word(j).text = rep Then
    r = j
    Exit For
  End If
Next j

If f = 0 Then
  Chn.NumWords = Chn.NumWords + 1
  f = Chn.NumWords
  ReDim Preserve Chn.word(Chn.NumWords)
  With Chn.word(Chn.NumWords)
    .text = word
    .NumReps = 0
  End With
End If
If r = 0 Then
  Chn.NumWords = Chn.NumWords + 1
  r = Chn.NumWords
  ReDim Preserve Chn.word(Chn.NumWords)
  With Chn.word(Chn.NumWords)
    .text = rep
    .NumReps = 0
  End With
End If

Chn.word(f).NumReps = Chn.word(f).NumReps + 1
ReDim Preserve Chn.word(f).rep(Chn.word(f).NumReps)
Chn.word(f).rep(Chn.word(f).NumReps) = r
  
End Sub

Public Function GetRep(Chn As ChainType, word As String) As String

Dim j As Integer

For j = 1 To Chn.NumWords
  If Chn.word(j).text = word And Chn.word(j).NumReps > 0 Then
    GetRep = Chn.word(Chn.word(j).rep(Int(Rnd(1) * Chn.word(j).NumReps) + 1)).text
    Exit For
  End If
Next j

End Function


Public Sub MsgChain(Chn As ChainType)

Dim j As Long, k As Long, temp As String

For j = 1 To Chn.NumWords
  temp = temp + Chn.word(j).text + ": "
  For k = 1 To Chn.word(j).NumReps
    temp = temp + Chn.word(Chn.word(j).rep(k)).text + "; "
  Next k
  temp = temp + Chr(13) + Chr(10)
Next j
MsgBox temp

End Sub


